unit KExport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  wcrypt2, StdCtrls, Buttons, ExtCtrls;

type
  TExportForm = class(TForm)
    Label1: TLabel;
    ContainerEdit: TEdit;
    SaveDialog1: TSaveDialog;
    ExportGroupBox: TGroupBox;
    KEKCheckBox: TCheckBox;
    SKCheckBox: TCheckBox;
    OKBtn: TBitBtn;
    CloseBtn: TBitBtn;
    WhatRadioGroup: TRadioGroup;
    PasswLabel: TLabel;
    PasswEdit: TEdit;
    Passw2Edit: TEdit;
    Passw2Label: TLabel;
    procedure CloseBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure WhatRadioGroupClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ExportForm: TExportForm;

implementation

{$R *.DFM}

procedure TExportForm.CloseBtnClick(Sender: TObject);
begin
Close;
end;

procedure TExportForm.OKBtnClick(Sender: TObject);
var cont: PChar;
    err: string;
    hProv: HCRYPTPROV;
    key, expKey: HCRYPTKEY;
    pbuf: PBYTE;
    buflen: DWORD;
    f: file;
    hash: HCRYPTHASH;
begin
if not (KEKCheckBox.Checked or SKCheckBox.Checked) then exit;
if PasswEdit.Enabled and (PasswEdit.Text <> Passw2Edit.Text) then
   begin
   MessageDlg('   !  .', mtError, [mbOK], 0);
   exit;
   end;
if length(ContainerEdit.Text) = 0
then
    begin
    cont := nil;
    err := ' ';
    end
else
    begin
    err := ContainerEdit.Text;
    cont := StrAlloc(length(err) + 1);
    StrPCopy(cont, err);
    end;
if not CryptAcquireContext(@hProv, cont, nil, PROV_RSA_FULL, 0)
then
    begin
    case int64(GetLastError) of
    ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
    ERROR_NOT_ENOUGH_MEMORY: err := 'ERROR_NOT_ENOUGH_MEMORY';
    NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
    NTE_BAD_KEYSET: err := 'NTE_BAD_KEYSET';
    NTE_BAD_KEYSET_PARAM: err := 'NTE_BAD_KEYSET_PARAM';
    NTE_BAD_PROV_TYPE: err := 'NTE_BAD_PROV_TYPE';
    NTE_BAD_SIGNATURE: err := 'NTE_BAD_SIGNATURE';
    NTE_EXISTS: err := 'NTE_EXISTS';
    NTE_KEYSET_ENTRY_BAD: err := 'NTE_KEYSET_ENTRY_BAD';
    NTE_KEYSET_NOT_DEF: err := 'NTE_KEYSET_NOT_DEF';
    NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
    NTE_PROV_DLL_NOT_FOUND: err := 'NTE_PROV_DLL_NOT_FOUND';
    NTE_PROV_TYPE_ENTRY_BAD: err := 'NTE_PROV_TYPE_ENTRY_BAD';
    NTE_PROV_TYPE_NO_MATCH: err := 'NTE_PROV_TYPE_NO_MATCH';
    NTE_PROV_TYPE_NOT_DEF: err := 'NTE_PROV_TYPE_NOT_DEF';
    NTE_PROVIDER_DLL_FAIL: err := 'NTE_PROVIDER_DLL_FAIL';
    NTE_SIGNATURE_FILE_BAD: err := 'NTE_SIGNATURE_FILE_BAD';
    else err := 'Unknown error';
    end;
    MessageDlg('  : ' + err, mtError, [mbOK], 0);
    exit;
    end;
if WhatRadioGroup.ItemIndex > 0 then
   begin
   if not CryptCreateHash(hProv, CALG_SHA, 0, 0, @hash) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      ERROR_NOT_ENOUGH_MEMORY: err := 'ERROR_NOT_ENOUGH_MEMORY';
      NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
      else err := 'Unknown error';
      end;
      MessageDlg('  -: ' + err, mtError, [mbOK], 0);
      exit;
      end;
   if not CryptHashData(hash, @(PasswEdit.Text[1]), length(PasswEdit.Text), 0) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_HASH: err := 'NTE_BAD_HASH';
      NTE_BAD_HASH_STATE: err := 'NTE_BAD_HASH_STATE';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_LEN: err := 'NTE_BAD_LEN';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_FAIL: err := 'NTE_FAIL';
      NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
      else err := 'Unknown error';
      end;
      MessageDlg('  : ' + err, mtError, [mbOK], 0);
      exit;
      end;
   if not CryptDeriveKey(hProv, CALG_RC4, hash, 0, @expKey) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_HASH: err := 'NTE_BAD_HASH';
      NTE_BAD_HASH_STATE: err := 'NTE_BAD_HASH_STATE';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_FAIL: err := 'NTE_FAIL';
      else err := 'Unknown error';
      end;
      MessageDlg('Error of CryptHashData: '+err,
                        mtError, [mbOK], 0);
      exit;
      end;
   if not CryptDestroyHash(hash) then
      begin
      case int64(GetLastError) of
      ERROR_BUSY: err := 'ERROR_BUSY';
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
      NTE_BAD_HASH: err := 'NTE_BAD_HASH';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      else err := 'Unknown error';
      end;
      MessageDlg('   : ' + err, mtError, [mbOK], 0);
      end;
   end;
if KEKCheckBox.Checked then
 repeat
   if not CryptGetUserKey(hProv, AT_KEYEXCHANGE, @key) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_NO_KEY: err := 'NTE_NO_KEY';
      else err := 'Unknown error';
      end;
      MessageDlg('    : ' + err,
                         mtError, [mbOK], 0);
      break;
      end;
   {$B-}
   if ((WhatRadioGroup.ItemIndex = 0) and
      not CryptExportKey(key, 0, PUBLICKEYBLOB, 0, nil, @bufLen))
      or ((WhatRadioGroup.ItemIndex = 1) and
      not CryptExportKey(key, expKey, PRIVATEKEYBLOB, 0, nil, @bufLen)) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      ERROR_MORE_DATA: err := 'ERROR_MORE_DATA';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_KEY_STATE: err := 'NTE_BAD_KEY_STATE';
      NTE_BAD_PUBLIC_KEY: err := 'NTE_BAD_PUBLIC_KEY';
      NTE_BAD_TYPE: err := 'NTE_BAD_TYPE';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_NO_KEY: err := 'NTE_NO_KEY';
      else err := 'Unknown error';
      end;
      MessageDlg('   BLOB''   : ' + err,
                         mtError, [mbOK], 0);
      break;
      end;
   GetMem(pbuf, bufLen);
   if ((WhatRadioGroup.ItemIndex = 0) and
      not CryptExportKey(key, 0, PUBLICKEYBLOB, 0, pbuf, @bufLen))
      or ((WhatRadioGroup.ItemIndex = 1) and
      not CryptExportKey(key, expKey, PRIVATEKEYBLOB, 0, pbuf, @bufLen)) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      ERROR_MORE_DATA: err := 'ERROR_MORE_DATA';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_KEY_STATE: err := 'NTE_BAD_KEY_STATE';
      NTE_BAD_PUBLIC_KEY: err := 'NTE_BAD_PUBLIC_KEY';
      NTE_BAD_TYPE: err := 'NTE_BAD_TYPE';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_NO_KEY: err := 'NTE_NO_KEY';
      else err := 'Unknown error';
      end;
      MessageDlg('    : ' + err,
                         mtError, [mbOK], 0);
      break;
      end;
   if not CryptDestroyKey(key) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      else err := 'Unknown error';
      end;
      MessageDlg('     : ' + err,
                         mtError, [mbOK], 0);
      end;
   SaveDialog1.Title := '      ';
   if SaveDialog1.Execute then
      begin
      AssignFile(f, SaveDialog1.FileName);
      rewrite(f, 1);
      BlockWrite(f, pbuf^, bufLen);
      CloseFile(f);
      MessageDlg('    ', mtInformation, [mbOK], 0);
      end;
 until true; {KeyExchange}
if SKCheckBox.Checked then
 repeat
   if not CryptGetUserKey(hProv, AT_SIGNATURE, @key) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_NO_KEY: err := 'NTE_NO_KEY';
      else err := 'Unknown error';
      end;
      MessageDlg('   : ' + err,
                         mtError, [mbOK], 0);
      break;
      end;
   {$B-}
   if ((WhatRadioGroup.ItemIndex = 0) and
      not CryptExportKey(key, 0, PUBLICKEYBLOB, 0, nil, @bufLen))
      or ((WhatRadioGroup.ItemIndex = 1) and
      not CryptExportKey(key, expKey, PRIVATEKEYBLOB, 0, nil, @bufLen)) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      ERROR_MORE_DATA: err := 'ERROR_MORE_DATA';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_KEY_STATE: err := 'NTE_BAD_KEY_STATE';
      NTE_BAD_PUBLIC_KEY: err := 'NTE_BAD_PUBLIC_KEY';
      NTE_BAD_TYPE: err := 'NTE_BAD_TYPE';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_NO_KEY: err := 'NTE_NO_KEY';
      else err := 'Unknown error';
      end;
      MessageDlg('   BLOB''  : ' + err,
                         mtError, [mbOK], 0);
      break;
      end;
   GetMem(pbuf, bufLen);
   if ((WhatRadioGroup.ItemIndex = 0) and
      not CryptExportKey(key, 0, PUBLICKEYBLOB, 0, pbuf, @bufLen))
      or ((WhatRadioGroup.ItemIndex = 1) and
      not CryptExportKey(key, expKey, PRIVATEKEYBLOB, 0, pbuf, @bufLen)) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      ERROR_MORE_DATA: err := 'ERROR_MORE_DATA';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_KEY_STATE: err := 'NTE_BAD_KEY_STATE';
      NTE_BAD_PUBLIC_KEY: err := 'NTE_BAD_PUBLIC_KEY';
      NTE_BAD_TYPE: err := 'NTE_BAD_TYPE';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_NO_KEY: err := 'NTE_NO_KEY';
      else err := 'Unknown error';
      end;
      MessageDlg('   : ' + err,
                         mtError, [mbOK], 0);
      break;
      end;
   if not CryptDestroyKey(key) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      else err := 'Unknown error';
      end;
      MessageDlg('    : ' + err,
                         mtError, [mbOK], 0);
      end;
   SaveDialog1.Title := '     ';
   if SaveDialog1.Execute then
      begin
      AssignFile(f, SaveDialog1.FileName);
      rewrite(f, 1);
      BlockWrite(f, pbuf^, bufLen);
      CloseFile(f);
      MessageDlg('   ', mtInformation, [mbOK], 0);
      end;
 until true; {Signature}
if WhatRadioGroup.ItemIndex > 0 then
   if not CryptDestroyKey(expKey) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      else err := 'Unknown error';
      end;
      MessageDlg('    BLOB''a: ' + err,
                         mtError, [mbOK], 0);
      end;
if not CryptReleaseContext(hProv, 0) then
   begin
   case int64(GetLastError) of
   ERROR_BUSY: err := 'ERROR_BUSY';
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   else err := 'Unknown error';
   end;
   MessageDlg('   : ' + err,
       mtError, [mbOK], 0);
   end;
end;

procedure TExportForm.WhatRadioGroupClick(Sender: TObject);
var e: boolean;
begin
e := (WhatRadioGroup.ItemIndex > 0);
PasswEdit.Enabled := e;
PasswLabel.Enabled := e;
Passw2Edit.Enabled := e;
Passw2Label.Enabled := e;
end;

end.
