unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, wcrypt2;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    KeysSubMenu: TMenuItem;
    ContainerItem: TMenuItem;
    GenerationItem: TMenuItem;
    ExportItem: TMenuItem;
    SignsSubMenu: TMenuItem;
    SignItem: TMenuItem;
    VerifyItem: TMenuItem;
    ViewItem: TMenuItem;
    ViewMemo: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ImportItem: TMenuItem;
    procedure ContainerItemClick(Sender: TObject);
    procedure GenerationItemClick(Sender: TObject);
    procedure ExportItemClick(Sender: TObject);
    procedure ViewItemClick(Sender: TObject);
    procedure SignItemClick(Sender: TObject);
    procedure VerifyItemClick(Sender: TObject);
    procedure ImportItemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses Container, Generate, KExport, Signing, KImport;

{$R *.DFM}

procedure TMainForm.ContainerItemClick(Sender: TObject);
begin
ContainersForm.Show;
end;

procedure TMainForm.GenerationItemClick(Sender: TObject);
begin
GenerateForm.Show;
end;

procedure TMainForm.ExportItemClick(Sender: TObject);
begin
ExportForm.Show;
end;

function ByteToHex(b: byte): string;
var c1, c2: char;
begin
if b div 16 < 10
then c1 := chr(b div 16 + $30)
else c1 := chr(b div 16 + 55);
if b mod 16 < 10
then c2 := chr(b mod 16 + $30)
else c2 := chr(b mod 16 + 55);
ByteToHex := '' + c1 + c2;
end;

procedure TMainForm.ViewItemClick(Sender: TObject);
var f: file of byte;
    b, i: byte;
    s: string;
begin
OpenDialog1.Title := '     ';
if OpenDialog1.Execute then
   begin
   AssignFile(f, OpenDialog1.FileName);
   reset(f);
   s := ' ';
   read(f, b);
   s := s + ByteToHex(b);
   i := 1;
   while not eof(f) do
         begin
         read(f, b);
         s := s + '-' + ByteToHex(b);
         inc(i);
         if i = 20 then
            begin
            ViewMemo.Lines.Add(s);
            i := 0;
            s := '';
            end;
         end;
   if i > 0 then ViewMemo.Lines.Add(s);
   CloseFile(f);
   end;
end;

procedure TMainForm.SignItemClick(Sender: TObject);
begin
SigningForm.Show;
end;

procedure TMainForm.VerifyItemClick(Sender: TObject);
var err: string;
    hProv: HCRYPTPROV;
    key: HCRYPTKEY;
    alg: ALG_ID;
    hash: HCRYPTHASH;
    infile: file;
    size, test, textsize: DWORD;
    buf: PBYTE;
    signature, signkey: PBYTE;
begin
if not CryptAcquireContext(@hProv, nil, nil, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT)
then
    begin
    case int64(GetLastError) of
    ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
    ERROR_NOT_ENOUGH_MEMORY: err := 'ERROR_NOT_ENOUGH_MEMORY';
    NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
    NTE_BAD_KEYSET: err := 'NTE_BAD_KEYSET';
    NTE_BAD_KEYSET_PARAM: err := 'NTE_BAD_KEYSET_PARAM';
    NTE_BAD_PROV_TYPE: err := 'NTE_BAD_PROV_TYPE';
    NTE_BAD_SIGNATURE: err := 'NTE_BAD_SIGNATURE';
    NTE_EXISTS: err := 'NTE_EXISTS';
    NTE_KEYSET_ENTRY_BAD: err := 'NTE_KEYSET_ENTRY_BAD';
    NTE_KEYSET_NOT_DEF: err := 'NTE_KEYSET_NOT_DEF';
    NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
    NTE_PROV_DLL_NOT_FOUND: err := 'NTE_PROV_DLL_NOT_FOUND';
    NTE_PROV_TYPE_ENTRY_BAD: err := 'NTE_PROV_TYPE_ENTRY_BAD';
    NTE_PROV_TYPE_NO_MATCH: err := 'NTE_PROV_TYPE_NO_MATCH';
    NTE_PROV_TYPE_NOT_DEF: err := 'NTE_PROV_TYPE_NOT_DEF';
    NTE_PROVIDER_DLL_FAIL: err := 'NTE_PROVIDER_DLL_FAIL';
    NTE_SIGNATURE_FILE_BAD: err := 'NTE_SIGNATURE_FILE_BAD';
    else err := 'Unknown error';
    end;
    MessageDlg('  : ' + err, mtError, [mbOK], 0);
    exit;
    end;
OpenDialog1.Title := '    ';
if OpenDialog1.Execute then
   begin
   AssignFile(infile, OpenDialog1.FileName);
   reset(infile, 1);
   BlockRead(infile, alg, 4);
   BlockRead(infile, textsize, 4);
   GetMem(buf, textsize);
   BlockRead(infile, buf^, textsize, test);
   if test < textsize then
      begin
      MessageDlg('  !  .', mtError, [mbOK], 0);
      exit;
      end;
   BlockRead(infile, test, 4);
   GetMem(signature, test);
   BlockRead(infile, signature^, test);
   CloseFile(infile);
   end
else exit;
if not CryptCreateHash(hProv, alg, 0, 0, @hash) then
   begin
   case int64(GetLastError) of
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   ERROR_NOT_ENOUGH_MEMORY: err := 'ERROR_NOT_ENOUGH_MEMORY';
   NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
   NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
   NTE_BAD_KEY: err := 'NTE_BAD_KEY';
   NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
   else err := 'Unknown error';
   end;
   MessageDlg('  -: ' + err, mtError, [mbOK], 0);
   exit;
   end;
if not CryptHashData(hash, buf, textsize, 0) then
   begin
   case int64(GetLastError) of
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
   NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
   NTE_BAD_HASH: err := 'NTE_BAD_HASH';
   NTE_BAD_HASH_STATE: err := 'NTE_BAD_HASH_STATE';
   NTE_BAD_KEY: err := 'NTE_BAD_KEY';
   NTE_BAD_LEN: err := 'NTE_BAD_LEN';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   NTE_FAIL: err := 'NTE_FAIL';
   NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
   else err := 'Unknown error';
   end;
   MessageDlg('  : ' + err, mtError, [mbOK], 0);
   exit;
   end;
OpenDialog1.Title := '     ';
if OpenDialog1.Execute then
   begin
   AssignFile(infile, OpenDialog1.FileName);
   reset(infile, 1);
   size := FileSize(infile);
   GetMem(signkey, size);
   BlockRead(infile, signkey^, size);
   CloseFile(infile);
   end
else exit;
if not CryptImportKey(hProv, signkey, size, 0, 0, @key) then
   begin
   case int64(GetLastError) of
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
   NTE_BAD_DATA: err := 'NTE_BAD_DATA';
   NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
   NTE_BAD_TYPE: err := 'NTE_BAD_TYPE';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   NTE_BAD_VER: err := 'NTE_BAD_VER';
   else err := 'Unknown error';
   end;
   MessageDlg('  : ' + err, mtError, [mbOK], 0);
   exit;
   end;
FreeMem(signkey, size);
if CryptVerifySignature(hash, signature, test, key, nil, 0) then
   begin
   MessageDlg(' .', mtInformation, [mbOK], 0);
   SaveDialog1.Title := '     ';
   if SaveDialog1.Execute then
      begin
      AssignFile(infile, SaveDialog1.FileName);
      rewrite(infile, 1);
      BlockWrite(infile, buf^, textsize);
      CloseFile(infile);
      end;
   end
else
    begin
    case int64(GetLastError) of
    ERROR_INVALID_HANDLE: err := '   : ERROR_INVALID_HANDLE';
    ERROR_INVALID_PARAMETER: err := '   : ERROR_INVALID_PARAMETER';
    NTE_BAD_FLAGS: err := '   : NTE_BAD_FLAGS';
    NTE_BAD_HASH: err := '   : NTE_BAD_HASH';
    NTE_BAD_KEY: err := '   : NTE_BAD_KEY';
    NTE_BAD_SIGNATURE: err := ' !';
    NTE_BAD_TYPE: err := '   : NTE_BAD_TYPE';
    NTE_BAD_UID: err := '   : NTE_BAD_UID';
    NTE_NO_MEMORY: err := '   : NTE_NO_MEMORY';
    else err := '   : Unknown error';
    end;
    MessageDlg(err, mtError, [mbOK], 0);
    end;
if not CryptDestroyKey(key) then
   begin
   case int64(GetLastError) of
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_KEY: err := 'NTE_BAD_KEY';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   else err := 'Unknown error';
   end;
   MessageDlg('    : ' + err,
                         mtError, [mbOK], 0);
   end;
if not CryptDestroyHash(hash) then
   begin
   case int64(GetLastError) of
   ERROR_BUSY: err := 'ERROR_BUSY';
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
   NTE_BAD_HASH: err := 'NTE_BAD_HASH';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   else err := 'Unknown error';
   end;
   MessageDlg('   : ' + err, mtError, [mbOK], 0);
   end;
if not CryptReleaseContext(hProv, 0) then
   begin
   case int64(GetLastError) of
   ERROR_BUSY: err := 'ERROR_BUSY';
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   else err := 'Unknown error';
   end;
   MessageDlg('   : ' + err,
       mtError, [mbOK], 0);
   end;
end;

procedure TMainForm.ImportItemClick(Sender: TObject);
begin
ImportForm.Show;
end;

end.
